
/**
 * /!\ This file is automatically generated by QLALR from CooLexerIO.g.
 * /!\ Don't edit it!
 */

#ifndef CHABACOOLEXER_HPP
#define CHABACOOLEXER_HPP

#include <editors/text/TextUtils.hpp>
#include <io/CooLexerIO.hpp>

class ChabaPlugin;

class ChabaCooLexer : public CooLexerIO
{
	Q_OBJECT

public:
	ChabaCooLexer(QObject *parent = nullptr, ChabaPlugin *plugin = nullptr) : CooLexerIO(parent), _plugin(plugin) {}
	virtual ~ChabaCooLexer() override = default;

	enum Marker
	{
		/** reference marker */
		Reference = TextMarker::INFO + 2
	};
	// QsciLexerCustom
	enum Styles
	{
		/** Flag when the point is a reference (is present in both actif and passive) */
		PointRef = 0b10000, // 16
	};
	enum class Type
	{
		Active,
		Passive,
		Out
	};

	// CooLexerIO
	virtual QString description(int style) const override;
	QColor defaultColor(int style) const override;
	QFont defaultFont(int style) const override;

	void type(Type type) noexcept { _type = type; }
	Type type() const noexcept { return _type; }

protected:
	// LexerParser
	virtual bool startLexer(int start, int end) override;
	// CooLexerIO
	virtual void gotPointName(QStringRef sym) override;
	virtual void gotPointCoordinate(QStringRef sym) override { addRefStyle(sym); }
	virtual void gotPointSigma(QStringRef sym) override { addRefStyle(sym); }
	virtual void gotPointDisplacement(QStringRef sym) override { addRefStyle(sym); }
	virtual void gotPointInfo(QStringRef sym) override { addRefStyle(sym); }
	virtual void gotPointType(QStringRef sym) override { addRefStyle(sym); }

private:
	void addRefStyle(QStringRef sym);

private:
	/** plugin */
	ChabaPlugin *_plugin = nullptr;
	bool _refPoint = false;
	Type _type = Type::Out;
};

#endif // CHABACOOLEXER_HPP
